package de.ullisroboterseite.ursai2alarm;

import android.app.AlarmManager;
import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;

import android.os.PowerManager;
import android.view.WindowManager;

import android.util.Log;

public class AlarmReceiver extends BroadcastReceiver {
    static final String LOG_TAG = UrsAI2Alarm.LOG_TAG;

    static PowerManager.WakeLock wakeLock = null;

    public static void acquire(Context ctx) {
        if (wakeLock != null)
            wakeLock.release();

        PowerManager pm = (PowerManager) ctx.getSystemService(Context.POWER_SERVICE);
        wakeLock = pm.newWakeLock(
                PowerManager.FULL_WAKE_LOCK | PowerManager.ACQUIRE_CAUSES_WAKEUP | PowerManager.ON_AFTER_RELEASE,
                LOG_TAG);
        wakeLock.acquire();
    }

    public static void release() {
        if (wakeLock == null)
            return;
        wakeLock.release();
        wakeLock = null;
    }

    /**
     * Wird ausgelöst, wenn der Alarmzeitpunkt erreicht ist.
     * @param context
     * @param alarmIntent Der Intent enthält alle Informationen, die zum einer App notwendig sind.
     */
    @Override
    public void onReceive(Context context, Intent alarmIntent) {
        acquire(context);
        Log.d(LOG_TAG, "Alarm received");
        Intent intent = AlarmIntent.buildFromIntentExtras(context, alarmIntent);
        release();

        try {
            context.startActivity(intent);
        } catch (Exception e) {
            DebugUtil.LogExecption("Alarmreceiver: Start Activity", e);
        }
    }
}